module Tut06 where

import Test.QuickCheck ( (==>), Property )

{-T6.1-}
length' :: [a] -> Integer
length' = foldr (const (+1)) 0

map' :: (a -> b) -> [a] -> [b]
map' f = foldr ((:) . f) []

reverse' :: [a] -> [a]
reverse' = foldr (\x -> (++[x])) []

minimum' :: Ord a => a -> [a] -> a
minimum' = foldr min

fib :: Integer -> Integer
fib n = fst $ foldr (\_ (pprev,prev) -> (prev, pprev+prev)) (0,1) [1..n]

inits' :: [a] -> [[a]]
inits' xs = snd $
  foldr (\_ (xsInner,res) -> (init xsInner, xsInner:res)) (xs,[]) [0..length xs]

squareOn :: (Eq a, Num a) => [a] -> a -> a
squareOn = foldr (\x acc y -> if y == x then x*x else acc y) id

compose :: [a -> a] -> a -> a
compose = foldr (.) id

{-T6.2-}
iter :: Int -> (a -> a) -> a -> a
iter n f x
  | n <= 0 = x
  | otherwise = iter (n - 1) f (f x)

pow :: Int -> Int -> Int
pow n k = iter k (n*) 1

drop' :: Int -> [a] -> [a]
drop' n = iter n tail

replicate' :: Int -> a -> [a]
replicate' n x = iter n (x:) []

iterWhile :: (a -> a -> Bool) -> (a -> a) -> a -> a
iterWhile test f x =
  let x' = f x in
  if test x x' then iterWhile test f x'
               else x

findSup :: Ord a => (a -> a) -> a -> a -> a
findSup f m = iterWhile (const (<=m)) f

{-T6.3-}
type ChurchNum a = (a -> a) -> a -> a

zero :: ChurchNum a
zero f x = x

one :: ChurchNum a
one f x = f x

two :: ChurchNum a
two f x = f (f x)

fromInt :: Int -> ChurchNum a
fromInt = iter

toInt :: ChurchNum Int -> Int
toInt n = n (+1) 0

prop_fromTo :: Int -> Property
prop_fromTo x = x >= 0 ==> toInt (fromInt x) == x

succ :: ChurchNum a -> ChurchNum a
succ n f x = f $ n f x

plus :: ChurchNum a -> ChurchNum a -> ChurchNum a
plus n m f x = n f $ m f x

mult :: ChurchNum a -> ChurchNum a -> ChurchNum a
mult n m f x = n (m f) x

prop_mult :: Int -> Int -> Property
prop_mult x y = min x y >= 0 ==> x * y == toInt (fromInt x `mult` fromInt y)